% demo_LSOD.m
%
% (c) Masashi Sugiyama, Department of Compter Science, Tokyo Institute of Technology, Japan.
%     sugi@cs.titech.ac.jp,     http://sugiyama-www.cs.titech.ac.jp/~sugi/software/LSOD/

clear all

rand('state',0);
randn('state',0);

%%%%%%%%%%%%%%%%%%%%%%%%% Generating data
x_mo=randn(1,1000);
x_ev=[randn(1,100) 5];
bin=[-3:0.5:5];
axis_param=[-4 7 0 inf];

%%%%%%%%%%%%%%%%%%%%%%%%% Estimating density ratio
wh_x_ev=uLSIF(x_ev,x_mo);

%%%%%%%%%%%%%%%%%%%%%%%%% Displaying results
figure(1)
clf

subplot(3,1,1)
hold on
set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
hist(x_mo,bin)
h = findobj(gca,'Type','patch');
set(h,'FaceColor','g','EdgeColor','k')
title('Inlier-based Outlier Detection by LSOD')
legend('Model samles')
axis(axis_param)

subplot(3,1,2)
hold on
set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
hist(x_ev,bin)
h = findobj(gca,'Type','patch');
set(h,'FaceColor','b','EdgeColor','k')
legend('Evaluation samles')
axis(axis_param)

subplot(3,1,3)
hold on
set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(x_ev,wh_x_ev,'ro','LineWidth',1,'MarkerSize',10)
legend('Outlier score')
xlabel('x')
axis(axis_param)

set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 18]);
print('-depsc','LSOD')
